import re,glob,os
try:
	set
except:
	from sets import set
	
def htmlize(s):
	s=s.replace("&","&amp;")
	s=s.replace("<","&lt;")
	s=s.replace(">","&gt;")
	return s

project=os.path.basename(os.getcwd())
todoItemRe=re.compile("--[ ]*(?:todo|xxx|fixme|fix)([!?]*):[ ]*(.+)$",re.I)
sourceFiles=glob.glob('*.lua')
functions={}
temp={}
docs={}
cats={}
undoc=[]
todos=[]
doc=file("API.html","w")
doc.write('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n')
doc.write("<html><head>\n<title>Documentation for %s</title><meta http-equiv=\"Content-Type\" content=\"text/html;charset=iso-8859-15\" />\n"%project)
doc.write("""
<style type="text/css">
body{background:white;margin:0.5em;}
body,td,th{font-family:arial,helvetica,sans-serif;font-size:10pt}
.func{margin-bottom:1em}
h1{border-top:2px solid #000;font-size:17pt;margin:0;background:lemonchiffon}
table{border-collapse:collapse;border:1px solid #888;margin-bottom:1em;margin-top:0.5em}
th{border-bottom:1px solid #888;padding-right:2em;background:lemonchiffon}
.in{font-style:italic;font-size:8pt;font-weight:normal}
.proto{margin-bottom:0.5em;font-size:8pt;font-weight:bold}
.sev1 td{background:orange}
.sev2 td{background:red}
.sev3 td{background:black;color:red;font-weight:bold}
.sev-1{color:gray}
.in{display:inline}
</style>
""")
doc.write("</head>\n<body>")
for fileName in sourceFiles:
	print "Processing %s"%fileName
	proto="(none)"
	funcName="(none)"
	for lineNo,line in enumerate(file(fileName)):
		line=line.strip()
		z=todoItemRe.search(line)
		if z:
			todos.append([funcName,fileName,lineNo+1,z.group(2).strip(),z.group(1)])			
		if line.startswith("-- @"):
			keyword,args=line[4:].split(" ",1)
			keyword=keyword.lower()
			if keyword=="desc":
				temp["desc"]=args
			elif keyword=="arg" or keyword=="param":
				if "args" not in temp:
					temp["args"]=[]
				temp["args"].append(args.split(" ",2))
			elif keyword=="ret":
				temp["ret"]=args.split(" ",1)
			elif keyword=="note":
				if "notes" not in temp:
					temp["notes"]=[]
				temp["notes"].append(args)
			elif keyword=="cat":
				temp["cats"]=args.split()
			else:
				print "** WARNING: Unrecognized kw",keyword
			temp["hasdocs"]=1
		if line.startswith("function") or line.startswith("local function"):
			if line.startswith("local"):
				line=line[6:]
				temp["local"]=True
			else:
				temp["local"]=False
			
			proto=line[9:]
			funcName=proto[:proto.find("(")].strip()
			if funcName=="":
				print "** INFO: Skipping anonymous function at %s:%d"%(fileName,lineNo+1)
			else:
				if "hasdocs" in temp:
					temp["proto"]=proto
					temp["name"]=funcName
					temp["line"]=lineNo+1
					temp["file"]=fileName
					docs[funcName]=temp
					print "  ",funcName
					if "cats" in temp:
						for cat in temp["cats"]:
							if cat not in cats:
								cats[cat]=set()
							cats[cat].add(funcName)
					temp={}
				else:
					undoc.append("%s (%s:%d)"%(funcName,fileName,lineNo+1))

funcs=sorted(docs.keys())
doc.write("<h1>%s API Documentation</h1>"%project)
doc.write("<a href=\"#todo\">Todo Items</a> | <a href=\"#undoc\">Undocumented Functions</a>\n")
lastPrefix=""
for funcName in funcs:
	if ":" in funcName:
		prefix=funcName[:funcName.find(":")]
	else:
		prefix="Globals"
	if prefix!=lastPrefix:
		if lastPrefix!="":
			doc.write("</ul>\n")
		doc.write("<h2>%s</h2>\n<ul>"%prefix)
		lastPrefix=prefix
	doc.write("  <li><a href=\"#%s\">%s</a></li>\n"%(funcName,funcName))
doc.write("</ul>")

if len(cats)>0:
	doc.write("<h2>Categories</h2>\n")
	for k in sorted(cats.keys()):
		doc.write("<h3>%s</h3>\n<ul>"%k)
		for z in sorted(list(cats[k])):
			doc.write("<li><a href=\"#%s\">%s</a></li>\n"%(z,z))
		doc.write("</ul>\n\n")
		
doc.write("\n")
for funcName in funcs:
	temp=docs[funcName]
	doc.write("<a name=\"%s\"></a>"%funcName)
	doc.write("<div class=\"func\">")
	doc.write("<h1>%s</h1>\n"%funcName)
	doc.write("<div class=\"proto\">%s"%temp["proto"])
	doc.write("<div class=\"in\">Defined in %s:%d</div>"%(temp["file"],temp["line"]))
	doc.write("</div>")

	doc.write("<div class=\"desc\">")
	if "desc" in temp:
		doc.write(htmlize(temp["desc"])+"\n")
	if "ret" in temp:
		doc.write("<br/>\n<b>Returns "+temp["ret"][0]+":</b> "+temp["ret"][1]+"\n")

	if "notes" in temp:
		doc.write("<h3>Notes</h3><ul>")
		for note in temp["notes"]:
			doc.write("  <li>%s</li>\n"%htmlize(note))
		doc.write("</ul>\n")

	doc.write("</div>\n")
	if "args" in temp:
		doc.write("<h2>Arguments</h2><table class=\"args\"><tr><th>Argument</th><th>Type</th><th>Description</th></tr>")
		for arg in temp["args"]:
			doc.write("<tr><td>%s</td><td>%s</td><td>%s</td></tr>"%(arg[0],arg[1],htmlize(arg[2])))
		doc.write("</table>")
	doc.write("</div>\n\n")
if len(undoc)>0:
	doc.write("<a name=\"undoc\"></a><h1>%d undocumented functions</h1><ul>"%len(undoc))
	for u in undoc:
		doc.write("<li>"+u+"</li>\n")
	doc.write("</ul>")
if len(todos)>0:
	doc.write("<a name=\"todo\"></a><h1>%d todo items</h1><table><tr><th>File</th><th>Function</th><th>Text</th></tr>\n"%len(todos))
	todo2=[]
	for (func,fn,ln,text,severity) in todos:
		severityLevel=len(severity)
		if "(done)" in text or "?" in severity:
			severityLevel=-1
			text=text.replace("(done)","").strip()
		todo2.append([severityLevel, "%s:%d"%(fn,ln), func, text])
	#print todos
	todo2.sort(key=lambda v:v[0],reverse=True)
	for (sev,p,f,t) in todo2:
		doc.write("  <tr class=\"sev%d\"><td>%s</td><td><a href=\"#%s\">%s</a></td><td>%s</td></tr>\n"%(sev,p,f,f,t))
	doc.write("</table>")
	
doc.write("</body></html>")